package greet;

import edu.ttu.cs.greeter.*;
import java.net.*;

// Command : java greet.MyGreet <basepath>  <baseurl>  <classes>

public class Greet {

    // Arguments to this application:
    //     args[0] - path name of directory in which class files
    //               for greeters are stored
    //     args[1], args[2], ... - class names of greeters to load
    //               and invoke the greet() method on.
    //
    // All greeters must implement the com.artima.greeter.Greeter
    // interface.
    //
    static public void main(String[] args) {

        if (args.length <= 1) {
            System.out.println(
                "Enter base path and greeter class names as args.");
            return;
        }
	
        for (int i = 2; i < args.length; ++i) {
             // Load the greeter specified on the command line
                Class c = null;
		    
		    try {	
		       c  = new GreeterClassLoader(args[0]).loadClass(args[i]); 
		    } catch (Exception e) { }
		    
		    if (c==null) 
       	        try {	
			     URL[] urls= { new URL( args[1] ) };
		           c  = new URLClassLoader(urls).loadClass(args[i]); 
		        } catch (Exception e) { }
		    
		    
		    if (c==null) 
				System.out.println("Could not load class : " + args[i]);
		    else  {
				 // Instantiate it into a greeter object
      	          Object o = null;
			    try { o= c.newInstance(); } catch (Exception e) { }
		
            	    // Cast the Object ref to the Greeter interface type
                	    // so greet() can be invoked on it
                	    Greeter greeter = (Greeter) o;

                	    // Greet the world in this greeter's special way
                	    String reply = greeter.greet();
                      System.out.println(reply);
		   }
	}
   }			  
}		    
